/*
 * Unique Schlüssel für JPA Entität
 */
package de.ivu.elect.business.ergebnis.entity;
import java.util.function.Function;
import java.util.ArrayList;
import java.util.stream.Collectors;

@javax.enterprise.inject.Vetoed
public class SitzeUK
implements de.ivu.elect.jee.entity.tk.EntityUK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;


  protected final de.ivu.elect.business.ergebnis.entity.ErgebnisUK ergebnisUK;

    public de.ivu.elect.business.ergebnis.entity.ErgebnisUK getErgebnisUK(){
      return ergebnisUK;
    }
  protected final de.ivu.elect.business.gebietsbaum.entity.GebietUK gebietUK;

    public de.ivu.elect.business.gebietsbaum.entity.GebietUK getGebietUK(){
      return gebietUK;
    }
  protected final de.ivu.elect.business.gruppe.entity.GruppeUK gruppeUK;

    public de.ivu.elect.business.gruppe.entity.GruppeUK getGruppeUK(){
      return gruppeUK;
    }

  public SitzeUK(
  de.ivu.elect.business.ergebnis.entity.ErgebnisUK ergebnisUK
,   de.ivu.elect.business.gebietsbaum.entity.GebietUK gebietUK
,   de.ivu.elect.business.gruppe.entity.GruppeUK gruppeUK
  ) {
    super();


        this.ergebnisUK = ergebnisUK;
      this.gebietUK = gebietUK;
      this.gruppeUK = gruppeUK;
    }

  @Override
  public int hashCode() {
        int result = 1;
    
    
        
                    result = result + ((ergebnisUK == null) ? 0 : ergebnisUK.hashCode());
                    result = result + ((gebietUK == null) ? 0 : gebietUK.hashCode());
                    result = result + ((gruppeUK == null) ? 0 : gruppeUK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    
    if (getClass() != obj.getClass()) {
      return false;
    }

            SitzeUK other = (SitzeUK) obj;

        
                if (ergebnisUK == null) {
          if (other.ergebnisUK != null) {
            return false;
          }
        } else if (!ergebnisUK.equals(other.ergebnisUK)) {
          return false;
        }
                if (gebietUK == null) {
          if (other.gebietUK != null) {
            return false;
          }
        } else if (!gebietUK.equals(other.gebietUK)) {
          return false;
        }
                if (gruppeUK == null) {
          if (other.gruppeUK != null) {
            return false;
          }
        } else if (!gruppeUK.equals(other.gruppeUK)) {
          return false;
        }
            
    return true;
  }

  @Override
  public String getEntityMessageKey() {
    return SitzeConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(ergebnisUK.getAllEntityFieldValues());
    result.addAll(gebietUK.getAllEntityFieldValues());
    result.addAll(gruppeUK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            return java.util.Collections.emptyList();
      }
  
    @Override
  public String toString() {
    return "SitzeUK[" + toStringParameter() + "]";
  }

            protected String toStringParameter() {
              String result = ""

                                                                    +"ergebnisUK="+ergebnisUK
                            +", "                +"gebietUK="+gebietUK
                            +", "                +"gruppeUK="+gruppeUK
                        ;
                          return result;
            
            }




          public String allUKFields() {
    return String.join(", ", getAllUKFieldValues().stream()
         .map(object -> (object != null ? object.toString() : null))
         .collect(Collectors.toList()));
    }

   protected ArrayList<Object> getAllUKFieldValues() {
              ArrayList<Object> list = new ArrayList<>();
          return list;
   }

            public static <E extends Sitze> java.util.Map<SitzeUK, E> mappeSitzeNachUK(java.util.Collection<E> entities) {

                return entities.stream().collect(java.util.stream.Collectors.toMap(Sitze::getSitzeUK, Function.<E>identity(), (u,v)->v));
             }


                public static Function<Sitze, SitzeUK> getSitzeToUKFunction() {
                return Sitze::getSitzeUK;
                }

}
